<template>
  <mind-view>
		<template v-slot:toolbar-actions>
			<el-button
				type="primary"
				plain
				icon="Folder"
				@click="onNew()"
				>Nuevo Espacio
			</el-button>
		</template>
    <!-- <mind-filter :defaults="filtrosDefault" @submit="filtrar">
      <template v-slot="{fields}">
      </template>
    </mind-filter> -->
      <mind-table v-if="workspaceList && workspaceList.length > 0"
        :data="workspaceList"
        row-key="id"
        :actions="{edit:true, delete:true}"
        @edit="onEdit"   @delete="onDelete">
          <el-table-column  sortable prop="name" label="Nombre"  />
          <el-table-column  sortable prop="description" label="Descripción"  />
          <template v-slot:empty>
          </template>
      </mind-table>
      <el-empty v-else style="height: 100%;"
        description="Todavía no hay ningún espacio de trabajo">
        <el-button type="primary" @click="onNew()">Crear Espacio de Trabajo</el-button>
      </el-empty>

    <WorkspaceDialog
      v-model="workspaceModel"
      v-model:visible="dialogoWorkspaceVisible"
      @submit="onSubmit"
      title="Crear Espacio de Trabajo"
    />

    <template v-slot:child>
			<router-view :key="$route.fullPath"  ></router-view>
		</template>

  </mind-view>



</template>

<script setup>
  import { ref, onMounted } from 'vue'
  import WorkspaceDialog from '@/components/WorkspaceDialog.vue'
  import { useRouter, useRoute } from 'vue-router'
  import {useWorkspace} from '@/composables/workspace.js'
  import {ElMessageBox} from 'element-plus'

  const dialogoWorkspaceVisible = ref(false)
  const router = useRouter()
  const route = useRoute()
  const {state: workspaceList, fetchWorkspaces, createWorkspace, deleteWorkspace, newWorkspace} = useWorkspace()
  const workspaceModel = ref({})

  const onNew = () => {
    workspaceModel.value = newWorkspace()
    dialogoWorkspaceVisible.value = true
  }

  const onDelete = async (v) => {
    const id = v.id

    ElMessageBox.confirm("Esta acción eliminará TODOS los proyectos del espacio de trabajo", "Confirmar Eliminación", {})
      .then(()=>{
        deleteWorkspace(id)
          .then(()=>{
            ElMessageBox("el espacio de trabajo ha sido eliminado!")
          })
      }).catch(()=>{ })
  }

  const onEdit = (row) => {
    router.push(`${route.path}/${row.id}`)
  }

  const onSubmit = (v) => {
    createWorkspace(v).then((response)=>{
        dialogoWorkspaceVisible.value = false
        const id = response[0].id
        router.push(`${route.path}/${id}`)
    })
  }

  onMounted(async () => {
    await fetchWorkspaces()
  })


</script>